import React from 'react';
import { AppContext } from '../../../context/app'
import { AppData } from '../../../context/data'
import { WHITE, BLACK } from '../Stone'

export default function Create() {
    const ctx = Definitions()

    const onClick = () => {
        if (!ctx.hasPlayers) 
            return alert("Choose both black and white players");

        if (!ctx.hasCurrentUser)
            return alert("You must be one of the players");
    
        const request = ctx.get_GameProposalRequest()
        console.log("TODO: send GameCreateRequest to the server!", request)
    }

    return (
        <button
            className={'game-action create' + (ctx.isEnabled ? ' enabled' : ' disabled')}
            onClick={onClick}
        >
            Create
        </button>
    )
}

function Definitions() {
    const [ctx] = React.useContext(AppContext)
    const [data] = React.useContext(AppData)

    const isCurrentUser = data.isCurrentUser
    const whitePlayerName = ctx.newGame.whitePlayer
    const blackPlayerName = ctx.newGame.blackPlayer
    
    const hasPlayers = whitePlayerName !== blackPlayerName
        && whitePlayerName !== ''
        && blackPlayerName !== ''

    const hasCurrentUser = isCurrentUser(whitePlayerName) || isCurrentUser(blackPlayerName)
    
    const isEnabled = hasPlayers && hasCurrentUser

    const get_GameProposalRequest = () => {
        const [opponentName, opponentColor] = get_Opponent(isCurrentUser, whitePlayerName, blackPlayerName)

        return {
            opponentName,
            opponentColor,
            board: null,
            message: "let's play a game"
        }
    }
    
    return {
        hasPlayers,
        hasCurrentUser,
        isEnabled,

        get_GameProposalRequest,
    }
}

function get_Opponent(isCurrentUser, whitePlayerName, blackPlayerName) {
    if (isCurrentUser(whitePlayerName)) {
        return [blackPlayerName, BLACK()]
    }

    if (isCurrentUser(blackPlayerName)) {
        return [whitePlayerName, WHITE()]
    }

    return ['', '']
}
  